#!/bin/bash

##################################################
# gen_certifScribe
# generation du certificat pour scribe
# realise par samuel morin <samuel.morin@ac-dijon.fr>
###################################################

# Création intéractive d'une demande PKCS#10 décorée par un SubjectAltName.
# Le format de fichier de sortie est le suivant :
#
# SubjectAltName=fw-ecole-beaune.eole.ac-dijon.fr
# --- BEGIN PKCS#10 ---
# mldjmldfgjsmldfgjsdlmjgsdm
# --- END PKCS#10 ---

REQUETECONF=/etc/sysconfig/eole/certif-eole.conf
REQUETEDIR=/etc/ssl/apache2
CERTFILE="$REQUETEDIR/server.crt"
KEYFILE="$REQUETEDIR/server.key"

mkdir -p $REQUETEDIR

. ParseDico
echo "SubjectAltName=$nom_machine.$nom_domaine_local" > $CERTFILE

openssl req -x509 -new -newkey rsa:1024 -days 1825 -config $REQUETECONF -out $CERTFILE.tmp && cat $CERTFILE.tmp >> $CERTFILE

rm $CERTFILE.tmp

openssl rsa -in /tmp/key -passin pass:secret -out $KEYFILE

rm -f /tmp/key
