#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Mise à jour des mots de passe Mysql
# Scribe-2.0
# Equipe Eole eole@ac-dijon.fr

import os, sys, time

def modif_pass(fichier, user, attr, mdp, rpass):
    """
    @fichier : fichier de conf de l'appli
    @user : utilisateur mysql
    @attr : nom de l'attribut mot de passe dans le fichier de conf
    @mdp  : nouveau mot de passe mysql
    @rpass : mot de passe root de mysql
    """
    # modification du mot de passe mysql
    os.system("echo \"UPDATE user SET password=PASSWORD('%s') WHERE user='%s';flush  privileges;\" | mysql --password=\"%s\" mysql #>/dev/null" % (mdp,user,rpass))
    print "Mise à jour du fichier %s..."%fichier
    conf_file = open(fichier,"r")
    buffer_in = conf_file.readlines()
    conf_file.close()
    buffer_out = ""
    # on parcourt le fichier
    for line in buffer_in:
        # si la ligne actuelle contient la chaine recherchée
        if line.startswith(attr):
            #print "définition du mot de passe trouvée : "+line.strip()
            buffer_out += attr
            buffer_out += mdp
            if attr.endswith('"'):
                # si le mot de passe est entre guillemets, on ajoute le guillemet fermant
                buffer_out += '"'
            if fichier.endswith('.pl') or fichier.endswith('.pm') or fichier.endswith('.php'):
                buffer_out += ';'
            buffer_out += "\n"
        else:
            # sinon, on recopie la ligne d'origine
            buffer_out+=line
        
    # sauvegarde du fichier de conf
    conf_file = open(fichier, "w")
    conf_file.write(buffer_out)
    conf_file.close()


if __name__ == "__main__":

    print "## Réinitialisation des mots de passe Mysql ##"

    ask = False
    modify = False
    boucle = 0
    # demarrage de Mysql en mode Safe
    os.system("/etc/init.d/mysql stop >/dev/null")
    os.system("mysqld_safe --skip-grant-tables &>/dev/null &")
    while not os.path.exists("/var/run/mysqld/mysqld.sock") :
        # on attend la mise en place du socket :)
        time.sleep(0.5)
        boucle += 1        
        if boucle > 30:
            sys.exit("ERREUR : Temps d'attente du socket Mysql dépassé !")

    try:
        new_pass = sys.argv[1]
    except:
        ask = True
        new_pass = ""       
        while len(new_pass) < 5:
            if new_pass != "":
                print "le mot de passe est trop court (5 caractères au moins)"
            new_pass = raw_input("\nNouveau mot de passe root mysql : ")
    
    os.system("echo \"UPDATE user SET password=PASSWORD('%s') WHERE user='root';flush  privileges;\" | mysql -u root mysql > /dev/null" % new_pass)
    
    os.system("/etc/init.d/mysql stop > /dev/null")
    os.system("/etc/init.d/mysql start")
    if ask == True:
        modif = raw_input("\nVoulez-vous que les autres mots de passe soient modifiés (oui/non) ? ")
        if modif not in ['oui','o','O']:
            modify = False
    elif len(sys.argv) == 3:
        modify = False

    if modify == True:       
        # generation de mots de passe
        entree,sortie=os.popen2("/usr/bin/pwgen -C")
        mdps = sortie.read().split()
        modif_pass('/etc/prelude-manager/prelude-manager.conf',                       'prelude',        'db_passwd ', mdps[0], new_pass)        
        modif_pass('/etc/prewikka/prewikka.conf',   'prewikka', '$mdp="',     mdps[1], new_pass)
