#!/bin/sh

# Parse le dico eole
. ParseDico

# Recuperation des mots de passe et login
eval `cat  /usr/share/sentinelle/password `


WWWHOME=/var/www/sentinelle
SentinelleDir=/usr/share/sentinelle-server
InstallDir=/usr/share/sentinelle

echo -n "Mise à jour de sentinelle-server            : "
if [ -d $SentinelleDir ] ; then
	rm -rf $SentinelleDir/*
else
	mkdir $SentinelleDir
fi
cp -rf $InstallDir/sentinelle/* $SentinelleDir


if [ -d /etc/sentinelle ] ; then
	cp -r /etc/sentinelle/*  $SentinelleDir/conf/local
fi

echo " OK"

echo -n "Mise à jour de la partie web dans /var/www  : "

if [ ! -d $WWWHOME ] ; then
	mkdir $WWWHOME
else
	rm -rf $WWWHOME/*
fi

cp -R $InstallDir/web/* $WWWHOME

EXPR="s/%%CLT_STOREPASS%%/$CLT_STOREPASS/g"
sed $EXPR $InstallDir/web/download/files/bin/go.bat > $WWWHOME/download/files/bin/go.bat
sed $EXPR $InstallDir/web/download/files/bin/go.sh >  $WWWHOME/download/files/bin/go.sh


echo " OK"

echo -n "Mise à jour des certificats                 : "
cp -f /etc/ssl/sentinelle/client.ts $WWWHOME/download/files/security/client.ts
cp -f /etc/ssl/sentinelle/client.ks $WWWHOME/download/files/security/client.ks
cp -f /etc/ssl/sentinelle/serveur.ks $SentinelleDir/security/serveur.ks
echo " OK"


# Génération de l'include zephir
echo -n "Mise à jour  des profiles                   : "
INC_ZEPHIR="$SentinelleDir/scripts/inc_connect.py"
echo "sUserName='$ZEPHIR_LOGIN'"    >   $INC_ZEPHIR
echo "sPasswd='$ZEPHIR_PASSWORD'"  >>   $INC_ZEPHIR
echo "sIp='$adresse_zephir:7080'" >>   $INC_ZEPHIR
echo "sUrlZephir='https://'+ sUserName +':'+ sPasswd + '@' + sIp" >>   $INC_ZEPHIR


# CREATION DU PROFIL PAR DEFAUT DE SENTINELLE =======================================
echo "utilisateur=<login zephir>
password=
serveur=$adresse_ip_eth0
usessl=yes
fps=1
speedalpha=2

bordure=non
geometry=1024x750

class_infosetabs_visu=panel.JPanelInfosEtabsEole
class_infosetabs_print=
class_infosetabs_graph=

url_zephir=https://$adresse_zephir:8090/
url_portailweb=https://%_USER_%:%_PASSWD_%@$adresse_zephir:8070/etab/get?rne=%infosetabs.rne%

url_pictogramme=https://$adresse_ip_eth0/sentinelle/classes/picto.php?action=GET&directory=
url_smile=https://$adresse_ip_eth0/sentinelle/images/smile
url_data=https://$adresse_ip_eth0/sentinelle/classes/CData.php" > $WWWHOME/download/files/profiles/default.ini

echo "url=https://$adresse_ip_eth0/sentinelle/download/
profile=../profiles/default.ini
install=non" >  $WWWHOME/download/files/sentinelle.ini


# Generation du mot de passe d'accès a la base sentinelle =========
echo "pooldb_mysql.user=$MYSQL_SENTINELLE_LOGIN"        >  $SentinelleDir/conf/db.conf
echo "pooldb_mysql.password=$MYSQL_SENTINELLE_PWD"      >> $SentinelleDir/conf/db.conf

echo "<?
define(\"DB_HOST\",\"localhost\");
define(\"DB_NAME\", \"persistance\");
define(\"DB_USER\",\"$MYSQL_SENTINELLE_LOGIN\");
define(\"DB_PASSWORD\",\"$MYSQL_SENTINELLE_PWD\");
?>" >  $WWWHOME/classes/inc.php

echo " OK"

# création de l'archive du client
echo -n "Génération du package client                : "
rm -rf $WWWHOME/download/files/sentinelleLinux.zip
rm -rf $WWWHOME/download/files/sentinelleWin.zip

DOSSIER=`pwd`
cd $WWWHOME/download/files/
# Package windows
zip -A sentinelleWin.zip sentinelle.ini Sentinelle.exe >/dev/null 2>&1

# Package linux
cp -rf $WWWHOME/download/tools/Launcher.jar Sentinelle.jar 

echo "unset AWT_TOOLKIT " > sentinelle.sh
echo "java -jar Sentinelle.jar -version:1.6" >> sentinelle.sh 
chmod +x sentinelle.sh
zip -A sentinelleLinux.zip sentinelle.ini  Sentinelle.jar sentinelle.sh >/dev/null 2>&1

if [ ! -e /etc/sentinelle/client/_client/etabs.txt ] ; then
	echo ""
	echo "ATTENTION : Le fichier de coordonnées des établissements"
	echo "n'éxiste pas"
fi

if [ ! -e /etc/sentinelle/client/_client/carte.png ] ; then
	echo ""
	echo "ATTENTION : La carte n'éxiste pas"
fi

cd $DOSSIER
echo " OK"
# ===================================================================================



